#ifndef _CODNS_HBT_H_
#define _CODNS_HBT_H_

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>

#define CODNS_HBI_VERSION   1
#define CODNS_HBI_QUERY     0x000 /* must be zero */
#define CODNS_HBI_ACK       0x001

typedef struct CoDNSHeartbeatInfo {
  struct timeval hi_sendTime;
  int            hi_versionNum;
  int            hi_ID;
  int            hi_statusVec;
  int            hi_avgLocalLookupMS;
  struct in_addr hi_nameServers[2];
}CoDNSHeartbeatInfo;

void Heartbeat_Receive(int fd, void *token);
void SendHeartbeatQueries(int sock);
int Heartbeat_Init(void);

/* defined in codnslib.h */
void ntoh_CoDNSHeartbeatInfo(CoDNSHeartbeatInfo* p);
void hton_CoDNSHeartbeatInfo(CoDNSHeartbeatInfo* p);
#endif // _CODNS_HBT_H_
