#!/usr/bin/perl
use strict;

my $path = "/usr/local/CoDNS"; # default directory
my $input;
my $res;

#########################################################################
# install path
print "where do you want to install[$path]? ";
chomp($input = <STDIN>);
$path = $input if ($input =~ /\//);

print "installing at $path...\n";
if (!(-d $path)) {
    print "want to create a new directory[$path] (y/n)? ";
    chomp($input = <STDIN>);
    system("mkdir -p $path") if (($input eq "y") || ($input eq "yes"));
}
die "can't create the directory" unless (-d $path);
$path =~ s/\/$//; # remove the trailing '/'

##########################################################################
# log file directory creation
system("mkdir $path/log") unless (-d "$path/log");

##########################################################################
# installation
if (-x "$path/codns_stop") {
    print "stopping current codns\n";
    system("$path/codns_stop >& /dev/null");
}
system("cp -f -p ./codns ./codns_stop ./forward_codns $path");
system("cp -f -p ./codns.conf ./CoDNSlogcompressor.pl $path");
system("chown -R root:wheel $path");

##########################################################################
# codns_start script
$res = open TEMP_FILE, "> $path/codns_start";
die "don't have the privilege to create ./codns_start\n" if ($res < 0);
$res = open START_FILE, "codns_start";
die "can't read ./codns_start\n" if ($res < 0);
while(<START_FILE>) {
    if (/chdir \$HOME/) {
	print TEMP_FILE "chdir \"$path\";\n";
    } else {
	print TEMP_FILE $_;
    }
}
close START_FILE;
close TEMP_FILE;
system("chmod u+x $path/codns_start");

##########################################################################
# add the start-up script in /etc/rc.d/rc.local
if (-e "/etc/rc.d/rc.local") {
    my $in = 0;

    open THIS_FILE, "/etc/rc.d/rc.local";
    while(<THIS_FILE>) {
	if (/$path\/codns_start/) {
	    $in = 1;
	    last;
	}
    }
    close THIS_FILE;
    if ($in == 0) {
	system("echo $path/codns_start >> /etc/rc.d/rc.local");
    }
} else {
    my $uname;

    chomp($uname = `uname`);
    if ($uname eq "Darwin") {
	system("cp -r -p Darwin/CoDNS /Library/StartupItems/");
	
	if ($path ne "/usr/local/CoDNS") {
	    $res = open TEMP_FILE, "> Library/StartupItems/CoDNS/CoDNS";
	    die "require root priviledge\n" if ($res < 0);
	    $res = open START_FILE, "Darwin/CoDNS/CoDNS";
	    die "can't read ./Darwin/CoDNS/CoDNS\n" if ($res < 0);
	    while(<START_FILE>) {
		if (/\/usr\/local\/CoDNS/) {
		    s/\/usr\/local\/CoDNS/$path/;
		}
		print TEMP_FILE $_;
	    }
	    close START_FILE;
	    close TEMP_FILE;
	}
	system("chown -R root:wheel Darwin/CoDNS");
    } else {
	print "please arrange to execute $path/codns_start at boot time\n";
    }
}

##########################################################################
print "intallation is done... \n";
print "executing the daemon $path/codns_start\n";
system("$path/codns_start");

